package org.apidesign.apifest08.currency;

import java.math.BigDecimal;
import java.util.Currency;

/** This is the skeleton class for your API. You need to make it public, so
 * it is accessible to your client code (currently in Task1Test.java) file.
 * <p>
 * Feel free to create additional classes or rename this one, just keep all
 * the API and its implementation in this package. Do not spread it outside
 * to other packages.
 */
public interface Convertor {
    /**
     * Methods converts some pounds
     * API design question - what kind of parameters?
     * I decided to use BigDecimal based on experience on Java conf ;-)
     * @param amountOfMoney
     * @return converted amount of money
     * @throws org.apidesign.apifest08.currency.CannotConvertException - if convertor is outdated or any other problem
     */

    BigDecimal convertCurrency1ToCurrency2(BigDecimal amountOfMoney) throws CannotConvertException;

    /**
     * Methods converts some pounds
     * API design question - what kind of parameters?
     * @param amountOfMoney
     * @return converted amount of money
     * @throws org.apidesign.apifest08.currency.CannotConvertException - if convertor is outdated or any other problem
     */

    BigDecimal convertCurrency2ToCurrency1(BigDecimal amountOfMoney) throws CannotConvertException;

    //handy getters

    /**
     * Getter - Returns Currency 1 of this convertor
     * @return money code
     */
    Currency getCurrency1();

    /**
     * Getter - Returns Currency 2 of this convertor
     * @return money code
     */
    Currency getCurrency2();

    // For Future purposes...? - it was not as a requirement in TestCase
    //BigDecimal getConversionValue();
}
