package org.apidesign.apifest08.currency;


import java.util.Date;


public final class DateRange
{
    private final Date from;
    private final Date till;
    
    DateRange(final Date f,
              final Date t)
    {
        if(f == null && t != null)
        {
            throw new IllegalArgumentException("f was null but t was not");
        }
        
        if(f != null && t == null)
        {
            throw new IllegalArgumentException("f was null but t was not");
        }
        
        from = f;
        till = t;
    }
    
    public Date getFrom()
    {
        return (from);
    }
    
    public Date getTill()
    {
        return (from);
    }
    
    public boolean isInRange(final Date date)
    {
        final boolean retVal;

        if(date.equals(from) || date.equals(till))
        {
            retVal = true;
        }
        else if(date.after(from) && date.before(till))
        {
            retVal = true;
        }
        else
        {
            retVal = false;
        }

        return (retVal);
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final DateRange other = (DateRange) obj;
        if (this.from != other.from && (this.from == null || !this.from.equals(other.from))) {
            return false;
        }
        if (this.till != other.till && (this.till == null || !this.till.equals(other.till))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 89 * hash + (this.from != null ? this.from.hashCode() : 0);
        hash = 89 * hash + (this.till != null ? this.till.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString()
    {
        return (from + " until " + till);
    }

}
