
package org.apidesign.apifest08.currency;

public final class CurrencyRateImpl implements CurrencyRate, TimeLimitedCurrencyRate {
    private String currency1;
    private String currency2;
    private Rate rate;
    private long fromTime;
    private long toTime;
    
    CurrencyRateImpl(final String currency1, final String currency2, final Rate rate) {
        if ((currency1 == null)||(currency2 == null) || (rate == null)) {
            throw new IllegalArgumentException("Argument cannot be null.");
        }
        if ("".equals(currency1) || "".equals(currency2)) {
            throw new IllegalArgumentException("Name of currency cannot be empty string");
        }
        if (currency1.equals(currency2)) {
            throw new IllegalArgumentException("Currencies in rate cannot be the same");
        }
       
        this.currency1 = currency1;
        this.currency2 = currency2;
        this.rate = rate;
        this.fromTime = Long.MIN_VALUE;
        this.toTime = Long.MAX_VALUE;
    }

    CurrencyRateImpl(final String currency1, final String currency2, final Rate rate, final long fromTime, final long toTime) {
        if ((currency1 == null)||(currency2 == null) || (rate == null)) {
            throw new IllegalArgumentException("Argument cannot be null.");
        }
        if ("".equals(currency1) || "".equals(currency2)) {
            throw new IllegalArgumentException("Name of currency cannot be empty string");
        }
        if (currency1.equals(currency2)) {
            throw new IllegalArgumentException("Currencies in rate cannot be the same");
        }
        if (fromTime > toTime) {
            throw new IllegalArgumentException("Invalid time range");
        }

        this.currency1 = currency1;
        this.currency2 = currency2;
        this.rate = rate;
        this.fromTime = fromTime;
        this.toTime = toTime;
    }

    public String getCurrency1() {
        return currency1;
    }
            
    public String getCurrency2() {
        return currency2;
    }

    public Rate getRate(){
        return rate;
    }

    public long getFromTime() {
        return fromTime;
    }

    public long getToTime() {
        return toTime;
    }

}
