package apifest;

import java.math.BigDecimal;
import java.util.Currency;
import junit.framework.TestCase;
import org.apidesign.apifest08.currency.Convertor;
import org.apidesign.apifest08.currency.InvalidConversionException;


/** Write a test that works with version from task A and fails with version B.
 */
public class CurrencyTest extends TestCase {
    public CurrencyTest(String n) {
        super(n);
    }
    
    public void testCompatibility() throws Exception {
        Convertor myOwnImplementationOfConvertor =
                new MyOwnImplementationOfConvertor();
        
        BigDecimal result = myOwnImplementationOfConvertor.convert(
                Currency.getInstance("CZK"),
                Currency.getInstance("USD"),
                new BigDecimal("1"));
        assertEquals(1, result.intValue());
    }
    
    class MyOwnImplementationOfConvertor implements Convertor {
        public BigDecimal convert(Currency from, Currency to, BigDecimal amount) throws InvalidConversionException {
            return amount; // not very smart implementation
        }
    }
}
