package apifest;

import junit.framework.TestCase;
import org.apidesign.apifest08.currency.Convertor;
import org.apidesign.apifest08.currency.ConvertorFactory;
import org.apidesign.apifest08.currency.CurrencyRate;
import org.apidesign.apifest08.currency.Rate;


/** Write a test that works with version from task A and fails with version B.
 */
public class CurrencyTest extends TestCase {
    public CurrencyTest(String n) {
        super(n);
    }
    
    public void testCompatibility() throws Exception {
        
        Convertor c = ConvertorFactory.newInstance().createConvertor(
                new MyOwnCurrencyRate("CZK", "USD", new Rate(1, 16), "ABCDEF"));
        
        MyOwnCurrencyRate[] arr = c.getCurrencyRates().toArray(new MyOwnCurrencyRate[1]);
        assertEquals("ABCDEF", arr[0].getMyImportantProperty());
    }
    
    class MyOwnCurrencyRate implements CurrencyRate {

        private final String currency1;
        private final String currency2;
        private final Rate rate;
        private final String myImportantProperty;
        
        public MyOwnCurrencyRate(String currency1, String currency2, Rate rate, String myImportantProperty) {
            this.currency1 = currency1;
            this.currency2 = currency2;
            this.rate = rate;
            this.myImportantProperty = myImportantProperty;
        }
        
        public String getCurrency1() {
            return currency1;
        }

        public String getCurrency2() {
            return currency2;
        }

        public Rate getRate() {
            return rate;
        }

        public String getMyImportantProperty() {
            return myImportantProperty;
        }
    }
}
