package apifest;

import java.math.BigDecimal;
import java.util.Currency;
import junit.framework.TestCase;
import org.apidesign.apifest08.currency.Amount;
import org.apidesign.apifest08.currency.Convertor;
import org.apidesign.apifest08.currency.UnsupportedConversionException;
//import static org.apidesign.apifest08.test.Currencies.CZK;
//import static org.apidesign.apifest08.test.Currencies.SKK;
//import static org.apidesign.apifest08.test.Currencies.USD;

/** Write a test that works with version from task A and fails with version B.
 */
public class CurrencyTest extends TestCase {
    public CurrencyTest(String n) {
        super(n);
    }
    
    public void testCompatibility() throws Exception {
        Currency CZK = Currency.getInstance("CZK");
        Currency USD = Currency.getInstance("USD");
        Currency SKK = Currency.getInstance("SKK");


        Convertor c = new Convertor(new BigDecimal(17), USD, CZK);
        try {
            Amount a = c.convert(new BigDecimal("10"), USD, SKK);
            //fail();
        } catch (UnsupportedConversionException e) {
            assertEquals("Conversion from  the currency USD to the currency SKK or vice versa in not supported.", e.getMessage());
        }
    }
}
